#include <Carbon.r>
#include "Globals.h"

resource 'MBAR' (rMainMenuBar, preload) {//resource ID, preload
	//menus appear in the order listed here
	{rAppleMenu, rFileMenu, rEditMenu}; //resource IDs for menus in this menu bar
};

resource 'MENU' (rAppleMenu, preload) { //resource ID, preload resource
	rAppleMenu,								//menu ID
	textMenuProc,							//uses standard menu definition procedure
	allEnabled, //0b1111111111111111111111111111101,		//enable About item,
											//disable divider,
											//enable all other items
	enabled,								//enable menu title
	apple,									//menu title
	{
		//first menu item
		"About...",							//text of menu item
											//(includes ellipsis)
											//item characteristics follow
		noicon,								//icon number (if any) or 
											//script code (if any)
		nokey,								//keyboard equivalent (if any)
											//orsubmenu (if any) or
											//small or reduced icon (if any)
		nomark,								//marking character (if any) or
											//menu ID of submenu (if any)
		plain; 								//style of menu item text
		//second menu item
		"-",								//item text (divider)
		noicon, nokey, nomark, plain /*item characteristics*/
	}
};

resource 'MENU' (rFileMenu, preload) {
	rFileMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"File", {/*
		"Close Window", noicon, "W", nomark, plain;
		"-", noicon, nokey, nomark, plain;
		"Display Mnemomic List", noicon, "L", nomark, plain;
		"New Mnemomic Window", noicon, "N", nomark, plain;*/
		"Quit", noicon, "Q", nomark, plain;
	}
};

resource 'MENU' (rEditMenu, preload) {
	rEditMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"Edit", {
		"Undo", noicon, "Z", nomark, plain;
/**/	"Redo", noicon, nokey, nomark, plain;//needs a key
		"-", noicon, nokey, nomark, plain;
		"Cut", noicon, "X", nomark, plain;
		"Copy", noicon, "C", nomark, plain;
		"Paste", noicon, "V", nomark, plain;
/**/	"Clear", noicon, nokey, nomark, plain;//needs a key
		"Select All", noicon, "A", nomark, plain;
		"-", noicon, nokey, nomark, plain;
	}
};


//resource ID 1 is the "version" string in get info
resource 'vers' (1) {	//'vers' resource defined in Types.r
	0x01,						//major version 1
	0x00,								//minor version 0
	development,								//development version
	0x04,										//(devel-release 3)
	verUS,										//region code (constants are defined in Script.r)
	"WC3 Autosave 1.0d4",						//short version string
	"WC3 Autosave v1.0d4.\nBy Keith Bennett"	//long version string
};

//resource ID 2 is the "info" string at the top of get info
resource 'vers' (2) {	//'vers' resource defined in Types.r
	0x01,						//major version 1
	0x00,								//minor version 0
	development,								//development version
	0x04,										//(devel-release 3)
	verUS,										//region code (constants are defined in Script.r)
	"WC3 Autosave 1.0d4",						//short version string
	"http://linkware.clan-mac.com/wc3autosave"	//long version string
};

