
#include <Carbon.h>
#include <stdio.h>
#include "Debugging.h"

bool DoAssert(const char *File, const int Line, bool check, int Type, void *Param, int ParamSize){
	if (check == true){
		DoDebug(File, Line, Type, Param, ParamSize);
		SysBeep(1);
		return false;
	}
	return true;
}

void DoDebug(const char *File, const int Line, int Type, void *Param, int ParamSize){
	FILE			*DbgFile;
	bool			KnownType, DoDefault;
	int				i;
	
	DbgFile = fopen("Debug.txt","a");
	fprintf(DbgFile, "\nDebug.txt opened.\n");
	fprintf(DbgFile, "\n%s %s (%i.%i.%i)", _PROGRAMNAME_, _VERSIONSTR_, _MAJORVER_, _MINORVER_, _BUGVER_);
	fprintf(DbgFile, "%s@%i\n", File, Line);
	fprintf(DbgFile, "Type: %i ", Type);
	
	KnownType = false;
	DoDefault = false;
	switch (Type){
		case kDbgType_UnhandledValue:
			fprintf(DbgFile, "(UnhandledValue)\n");
			KnownType = true;
			DoDefault = true;
			break;
		case kDbgType_SanityFailure:
			fprintf(DbgFile, "(SanityFailure)\nParam(s):\n");
			KnownType = true;
			DoDefault = true;
			break;
	/*	case kDbgType_CreationFailed:*/
		case kDbgType_ErrorReturned:
			fprintf(DbgFile, "(ErrorReturned)\nError Number: %i\n", *((OSErr *)Param));
			break;
		case kDbgType_Message:
			fprintf(DbgFile, "(Message)\n");
			for (i = 0; i < ParamSize; i++)
				fputc(((char *)Param)[i], DbgFile);
			break;
		default:
			DoDefault = true;
			break;
	}
	
	if (DoDefault == true){
		if (KnownType == false)
			fprintf(DbgFile, "(Unknown type, doing default type handler...)\n");
		DbgWriteHex(DbgFile, (char *)Param, ParamSize);
	}
	
	fprintf(DbgFile, "\nDebug.txt closed.\n\n");
	fclose(DbgFile);
}

void DbgWriteHex(void *DbgFile, char *Param, int ParamSize){
	int				i;
	unsigned char	current;
	
//	fprintf((FILE *)DbgFile, "\n");
	for (i=1;i<=ParamSize;i++){
		current = Param[i-1];
		if (current < 0x10)
			fprintf((FILE *)DbgFile, "0%x ",current);
		else
			fprintf((FILE *)DbgFile, "%x ",current);
		if (i%4==0)
		  fprintf((FILE *)DbgFile, "  ");
		if (i%16==0)
		  fprintf((FILE *)DbgFile, "\n");
	}
}
