
#include <Carbon.h>
//#include <stdio.h>//only used for MyDbg.txt !!

#include "Globals.h"
#include "Utilities.h"
#include "Debugging.h"

#include "replay.h"
#include "dump.h"

#define		DefaultName		"\pLastReplay.w3g"
#define		MapsName		"\pMaps"
#define		ReplaysName		"\preplay"

class WC3Autosave {
public:
	WC3Autosave();
	void				EnableMenuItems();
	void				GetReplayFolderID();
	void				CheckFile();
	void				Run();
	void				GetSubdir(char *Subdir);
	void				GetNewName(char *NewName);
	
private:
	Handle				MenuBar;
	EventLoopTimerRef	*Timer;
	UInt32				FolderVolume;
	UInt32				FolderID;
	UInt8				FolderPath[256];
	FSSpec				LastFile;
	FSRef				LastFileRef;
	FSCatalogInfo		LastFileInfo;
	replay				*LastReplay;
	game				*LastGame;
	void				Initialize();
};

pascal void TimerActivate(EventLoopTimerRef Timer, void *Program);
char * MyGetRace(int race);

WC3Autosave::WC3Autosave() {
	Initialize();
}

void WC3Autosave::EnableMenuItems(){
	MenuHandle	Menu;
	
	Menu = GetMenuHandle(rEditMenu);
	DisableMenuItem(Menu, 0);
	
	Menu = GetMenuHandle(rFileMenu);
	EnableMenuItem(Menu, 0);
	
	Menu = GetMenuHandle(rAppleMenu);
	EnableMenuItem(Menu, 0);
	
	DrawMenuBar();
	return;
}

void WC3Autosave::GetReplayFolderID(){
	OSErr			Error;
	FSSpec			Folder;
	FSRef			FolderRef;
	FSCatalogInfo	Info;
	
/*	if (FolderID != 0){
		//already found
		return;
	}*///it seems that this causes fnfErr when already found once before... (hmm...)
	
	Error = FSMakeFSSpec(0, 0, MapsName, &Folder);
	switch (Error){
	case noErr:
		//folder exists
		Error = FSpMakeFSRef(&Folder, &FolderRef);
		if (AssertError2(Error) == false){
			//assertion failure
			Info.volume = 0;
			Info.nodeID = 0;
		} else {
			Error = FSGetCatalogInfo(	\
				&FolderRef,				\
				kFSCatInfoVolume + kFSCatInfoNodeID,\
				&Info,					\
				NULL,					\
				NULL,
				NULL
			);
			if (AssertError2(Error) == false){
				//assertion failure
				Info.volume = 0;
				Info.nodeID = 0;
			}
		}
		
		Error = FSRefMakePath(&FolderRef, FolderPath, sizeof(FolderPath));
		if (AssertError2(Error) == false){
			//assertion failure
		}
		break;
	case fnfErr:
		//doesn't exist;
		Info.volume = 0;
		Info.nodeID = 0;
		break;
	default:
		AssertError2(Error);
		Info.volume = 0;
		Info.nodeID = 0;
		break;
	}
	
	Error = FSMakeFSSpec(Info.volume, Info.nodeID, ReplaysName, &Folder);
	switch (Error){
	case noErr:
		//folder exists
		Error = FSpMakeFSRef(&Folder, &FolderRef);
		if (AssertError2(Error) == false){
			//assertion failure
			Info.volume = 0;
			Info.nodeID = 0;
		} else {
			Error = FSGetCatalogInfo(	\
				&FolderRef,				\
				kFSCatInfoVolume + kFSCatInfoNodeID,\
				&Info,					\
				NULL,					\
				NULL,					\
				NULL
			);
			if (AssertError2(Error) == false){
				//assertion failure
				Info.volume = 0;
				Info.nodeID = 0;
			}
		}
		
		Error = FSRefMakePath(&FolderRef, FolderPath, sizeof(FolderPath));
		if (AssertError2(Error) == false){
			//assertion failure
			FolderPath[0] = 0;
		}
		break;
	case fnfErr:
		//doesn't exist
		Info.volume = 0;
		Info.nodeID = 0;
		break;
	default:
		AssertError2(Error);
		Info.volume = 0;
		Info.nodeID = 0;
		break;
	}
	
	FolderVolume = Info.volume;
	FolderID = Info.nodeID;
}

void WC3Autosave::CheckFile() {
	//if no file found, check local directory
	OSErr			Error;
	char			Namenum[16];
	char			Pathname[256];
	char			Buffer[256];
	Str255			NewName;
	FSSpec			Subdir;
	FSRef			SubdirRef;
	long			SubdirID, count, length;
	UniChar			UniName[256];
	UniCharCount	UniLength;
	bool			Success;
	
	
	GetReplayFolderID();
	
	Error = FSMakeFSSpec(FolderVolume, FolderID, DefaultName, &LastFile);
	switch (Error){
	case noErr:
		//file exists!
		//if FolderVolume and FolderID are 0, then get the values and set
		//if not, still need to get the mod date
		Error = FSpMakeFSRef(&LastFile, &LastFileRef);
		if (AssertError2(Error) == false){
			//assertion failure
			return;
			//FSRef isn't needed only here, it's needed later, otherwise i'd not return
		}
		if (FolderVolume == 0 && FolderID == 0){
			Error = FSGetCatalogInfo(	\
				&LastFileRef,			\
				kFSCatInfoVolume + kFSCatInfoNodeID + kFSCatInfoContentMod,\
				&LastFileInfo,			\
				NULL,					\
				NULL,					\
				&SubdirRef
			);
			if (AssertError2(Error) == false){
				//assertion failure
				LastFileInfo.volume = 0;
				LastFileInfo.nodeID = 0;
				LastFileInfo.contentModDate.highSeconds = 0;
				LastFileInfo.contentModDate.lowSeconds = 0;
				LastFileInfo.contentModDate.fraction = 0;
			}
			FolderVolume = LastFileInfo.volume;
			FolderID = LastFileInfo.nodeID;
		} else {
			Error = FSGetCatalogInfo(	\
				&LastFileRef,			\
				kFSCatInfoContentMod,\
				&LastFileInfo,			\
				NULL,					\
				NULL,					\
				&SubdirRef
			);
			if (AssertError2(Error) == false){
				//assertion failure
				LastFileInfo.contentModDate.highSeconds = 0;
				LastFileInfo.contentModDate.lowSeconds = 0;
				LastFileInfo.contentModDate.fraction = 0;
			}
		}
		
		if (LastReplay != NULL){
			FreeReplay(LastReplay);
			LastReplay = NULL;
		}
		if (LastGame != NULL){
			FreeGame(LastGame);
			LastGame = NULL;
		}
		
		MyPStrToCStr(Buffer, DefaultName);
		MyStrCpy(Pathname, (char *)FolderPath);
		MyStrCpy(Pathname + strlen((unsigned char *)Pathname), Buffer);
		
		LastReplay = rep_expand(Pathname, false);
		if (AssertSanity(LastReplay == NULL) == false){
			//assertion failure
		} else if (AssertSanity(LastReplay->data == NULL) == false){
			//assertion failure
		} else {
			LastGame = LoadGame(LastReplay, Pathname);
			if (AssertSanity(LastGame == NULL) == false){
				//assertion failure
			} else {
				//success, now to parse the file, move it, and rename
				GetSubdir(Buffer);
				MyCStrToPStr(NewName, Buffer);
				Error = FSMakeFSSpec(LastFile.vRefNum, LastFile.parID, NewName, &Subdir);
				switch (Error){
				case noErr:
					//exists
					break;
				case fnfErr:
					//doesn't exist
					Error = FSpDirCreate(&Subdir, smSystemScript, &SubdirID);
					if (AssertError2(Error) == false){
						//assertion failure
						return;
					}
					break;
				default:
					AssertError2(Error);
					return;
				}
				//convert the FSSpec to FSRef
				Error = FSpMakeFSRef(&Subdir, &SubdirRef);
				if (AssertError2(Error) == false){
					//assertion failure
					return;
				}
				//move the file
				Error = FSMoveObject(&LastFileRef, &SubdirRef, &LastFileRef);
				if (AssertError2(Error) == false){
					//assertion failure
					return;
				}
				//now to get the new name of the file
				GetNewName(Pathname);
				Success = false;
				count = -1;
				while (Success == false){
					count++;
					MyStrCpy(Buffer, Pathname);
					if (count > 0 ){
						MyStr(Namenum, count, 15);
						length = strlen((unsigned char *) Buffer);
						Buffer[length] = ' ';
						Buffer[length+1] = '#';
						MyStrCpy(Buffer + length + 2, Namenum);
					}
					MyCStrToPStr(NewName, Buffer);
					UniLength = (sizeof(UniName) / sizeof(UniChar));
					if (MyPStrToUnicode(UniName, &UniLength, NewName) == false){
						AssertSanity(true);
						return;
					}
/**/				//for some reason, FSRenameUnicode doesn't like having the length returned by ConvertFromPStringToUnicode(), but would rather have the number of characters...,
					//since a UniChar is 2 bytes long, I'll divide by two.
					UniLength /= 2;
					Error = FSRenameUnicode(&LastFileRef, UniLength, UniName, kTextEncodingMacRoman, &LastFileRef);
					if (Error == dupFNErr){
						//duplicate filename, try again
					} else if (AssertError2(Error) == false){
						//assertion failure
						return;
					} else {
						Success = true;
					}
				}
				//success
			}
		}
		break;
	case fnfErr:
/**/	//check folder which user has set
/**/	//need to get WarCraft III Folder/Maps/Replays
		break;
	default:
		AssertError2(Error);
	}
}

void WC3Autosave::Run() {
	//create event loop, check for appleevents.
	
	RunApplicationEventLoop();
	
}

void WC3Autosave::GetSubdir(char *Subdir){
	int		i;
	
	switch (LastGame->type){
	case T_1V1:
		MyStrCpy(Subdir, "1v1 or FFA");
		break;
	case T_CUST:
		MyStrCpy(Subdir, "Custom");
		break;
	case T_SINGLE:
		MyStrCpy(Subdir, "Single Player");
		break;
	case T_TEAM:
		i = LastGame->actual_players / 2;
		AssertSanity(LastGame->actual_players % 2 == 1);
		MyStr(Subdir, i, 0);
		MyStrCpy(Subdir + strlen((unsigned char *)Subdir), "v");
		MyStr(Subdir + strlen((unsigned char *)Subdir), i, 0);
//		MyStrCpy(Subdir + strlen((unsigned char *)Subdir), "-FFA");
		break;
	default:
		MyStrCpy(Subdir, "(Unknown Game Type)");
		break;
	}
}

void WC3Autosave::GetNewName(char *NewName){
	OSErr			Error;
	int				i, CurrentTeam, NumTeams, CountedPlayers, MaxNameLength;
	char			Buffer[256];
	bool			FirstPlayer, NameModified;
	LocalDateTime	LocalModDate;
	CountedPlayers = 0;
	
	switch (LastGame->actual_players){
	case 1:
	case 2:
	case 3:
		MaxNameLength = 255;//(no truncation)
		break;
	case 4:
	case 5:
		MaxNameLength = 8;
		break;
	case 6:
	case 7:
		MaxNameLength = 6;
		break;
	case 8:
	case 9:
	case 10:
	case 11:
	case 12:
		MaxNameLength = 4;
		break;
	default:
		AssertUnhandledValue2(true, LastGame->actual_players);
		MaxNameLength = 255;
		break;
	}
	//LastFileInfo.contentModDate;
	for (CurrentTeam = 0, NumTeams = 0, CountedPlayers = 0, NameModified = false; CurrentTeam <= NumTeams && CurrentTeam < T_OBSERVER; CurrentTeam++){
		for (i = 0, FirstPlayer = true; i < LastGame->player_slots; i++){
			if (LastGame->players[i] == NULL) continue;//unused player slot?
			
			if (LastGame->players[i]->race != 0){
				if (LastGame->players[i]->team == T_OBSERVER){ CountedPlayers++; continue;}
				if (LastGame->players[i]->team != CurrentTeam){
					if (LastGame->players[i]->team > NumTeams) NumTeams = LastGame->players[i]->team;
					continue;
				}
				NameModified = true;
				if (FirstPlayer == false){
					MyStrCpy(Buffer + strlen((unsigned char *)Buffer), ", ");
				} else {
					FirstPlayer = false;
				}
				MyStrCpy(Buffer + strlen((unsigned char *)Buffer), LastGame->players[i]->name, MaxNameLength);
				MyStrCpy(Buffer + strlen((unsigned char *)Buffer), " ");
				MyStrCpy(Buffer + strlen((unsigned char *)Buffer), MyGetRace(LastGame->players[i]->race));
				CountedPlayers++;
			} else {
/**/			AssertSanity(true);//should move to a "bad" folder
			}
		}
		if (NameModified == true && CountedPlayers < LastGame->actual_players){
			NameModified = false;
			MyStrCpy(Buffer + strlen((unsigned char *)Buffer), " vs ");
		}
	}
	
	Error = ConvertUTCToLocalDateTime(&LastFileInfo.contentModDate, &LocalModDate);
	if (AssertError2(Error) == false){
		//assertion failure
	} else {
		;
/*		AssertUnhandledValue2(true, LastFileInfo.contentModDate);
		AssertUnhandledValue2(true, LocalModDate);
		...need to eventually add the date/time to the filename
*/		
	}
	
	MyStrCpy(Buffer + strlen((unsigned char *)Buffer), ".w3g");
	MyStrCpy(NewName, Buffer);
/**///todo: verify unambiguous filename!!
/**///todo: add timestamp
}

void WC3Autosave::Initialize() {
	OSErr				Error;
	EventLoopTimerUPP	TimerUPP;
	MenuRef				CurrentMenu;
	
	InitCursor();
	
	MenuBar = GetNewMBar(rMainMenuBar);
	if (AssertCreation(MenuBar == NULL) == false){
		//assertion failure
	} else {
/**///when the program is a faceless background program, there's no need to set up the menubar
		SetMenuBar(MenuBar);
//		DisposeHandle(MenuBar);//let's keep the handle for a while?
		AppendResMenu(GetMenuHandle(rAppleMenu), 'DRVR');
		
		CurrentMenu = GetMenuHandle(rFileMenu);
		if (AssertSanity(CurrentMenu == NULL) == false){
			//assertion failure
		} else {
			Error = SetMenuItemCommandID(CurrentMenu, rFileQuit, kHICommandQuit);
			AssertError2(Error);
		}
		
		EnableMenuItems();
	}
	
	TimerUPP = NewEventLoopTimerUPP(&TimerActivate);
	Error = InstallEventLoopTimer(GetMainEventLoop(), 0, kEventDurationMinute, TimerUPP, this, Timer);
	AssertError2(Error);
	
	LastReplay = NULL;
	LastGame = NULL;
	FolderID = 0;
}

pascal void TimerActivate(EventLoopTimerRef Timer, void *Program){
	if (Timer == NULL){
		AssertSanity(true);
		return;
	}
	if (Program == NULL){
		AssertSanity(true);
		return;
	}
	
	((WC3Autosave *)Program)->CheckFile();
	
}

char * MyGetRace(int race){
	race &= ~R_FIXED; // clear out selectable bit, don't care right now
	switch (race) {
	case R_NE:	return("N");break;
	case R_ORC: return("O");break;
	case R_HUM: return("H");break;
	case R_UD:	return("U");break;
	case R_RAN: return("R");break;
//	default: return("?"); break;//commented out because it gets returned below
	}
	return("?");	
}

void main(void) {
	WC3Autosave theApplication;
	
	theApplication.Run();
	
	return;
}

